DEFINT A-Z

'$Include: 'pdqdecl.bas'
'$Include: 'pdqcom.Inc'

TYPE PCBoardSysType
     Display        AS STRING * 2
     Printer        AS STRING * 2
     PageBell       AS STRING * 2
     CallerAlarm    AS STRING * 2
     SysopFlag      AS STRING * 1
     ErrorCorrect   AS STRING * 2
     Graphics       AS STRING * 1
     Chat           AS STRING * 1
     BPSRateOpen    AS STRING * 5
     BPSConnect     AS STRING * 5
     RecordNumber   AS INTEGER
     firstname      AS STRING * 15
     Password       AS STRING * 12
     TimeinMin      AS INTEGER
     TimeUsed       AS INTEGER
     TimeLoggedOn   AS STRING * 5
     AllowedTime    AS INTEGER
     dlallowed      AS INTEGER
     areaexitfrom   AS STRING * 1
     AreasIn        AS STRING * 5
     areasInY       AS STRING * 5
     HighestAdd     AS INTEGER
     CreditTime     AS INTEGER
     language       AS STRING * 4
     UserName       AS STRING * 25
     minutesleft    AS INTEGER
     node           AS STRING * 1
     whenevent      AS STRING * 5
     eventactive    AS STRING * 2
     slideevent     AS STRING * 2
     memorized      AS SINGLE
     port           AS STRING * 1
     packflag       AS STRING * 1
     bpsflag        AS STRING * 1
END TYPE

TYPE UserType
    FirstLast      as string * 25
    CityState      AS STRING * 24
    Password        AS STRING * 12
    DataPhone       AS STRING * 13
    VoicePhone      AS STRING * 13
    LastDateOn      AS STRING * 6
    LastTimeOn      AS STRING * 5
    Expert          AS STRING * 1
    Protocol        AS STRING * 1
    RESERVED        as STRING * 1
    LastDIRlook     AS STRING * 6
    SecurityLevel   AS STRING * 1
    NumberTimesOn   AS Integer
    PageLength      AS STRING * 1
    Uploads         AS Integer
    Downloads       AS Integer
    DBsofar         AS STRING * 8
    UserComnt       AS STRING * 30
    SYSComnt        AS STRING * 30
    ElapsedTime     AS Integer
    RegisterDate    AS STRING * 6
    ExpiredSecrty   AS STRING * 1
    LastinArea      AS STRING * 1
    RegisteredIn    AS STRING * 5
    ExpiredIn       AS STRING * 5
    ScanIn          AS STRING * 5
    TotalBytesDl    AS STRING * 8
    TotalBytesUl    AS STRING * 8
    PositiveDelete  AS STRING * 1
    LastReadInMain  AS LONG
    LastReadConfs   AS STRING * 156
    SpaceExtra      AS STRING * 15
End Type

TYPE DTA                        'this is used by DOS find first/next service
     Reserved  AS STRING * 21   'reserved for use by DOS
     Attribute AS STRING * 1    'the file's attribute
     FileTime  AS STRING * 2    'the file's time
     FileDate  AS STRING * 2    'the file's date
     FileSize  AS LONG          'the file's size
     FileName  AS STRING * 13   'the file's name
END TYPE

     DECLARE SUB prnt (line$)
     DECLARE SUB Inpt (Line$, lnt)
     DECLARE SUB Waitn ()
     DECLARE SUB GetUserInfo (PCBfile$, UserNum%)
     DECLARE SUB GetSysInfo(PCBfile$)   

     CONST DoorName$ = "Survey Door v1.0 For PCBoard 14.x"
     CONST ReleaseDate$ = "May 10, 1990"
     CONST FileName$ = "SURVEY"
     CONST VerNum$ = "1.0"
     CONST False = 0
     CONST True = NOT False
     CONST NoEcho = 999
 
     DIM SHARED PCBoardsys AS PCBoardSysType
     DIM SHARED User as UserType
     DIM SHARED ActLnt
     DIM SHARED C
     DIM SHARED Bulletin
     DIM SHARED CreateBulletin
     DIM SHARED Timeout
     DIM SHARED END$
     DIM SHARED CLS$
     DIM SHARED Kolor
     DIM SHARED HotKey
     
     DIM Tempry as UserType
     DIM DTAData AS DTA              'this holds the file info for DOS as it works
     DIM SurveyAvail$(20)
     DIM Regstr as RegType
     DIM repAnswers(25)
     DIM SurvResp(20,25)
     DIM SurveyAnswer(25)
     
DEF FNLoadNames%
    STATIC count                     'this is a local variable
    regstr.DX = VARPTR(DTAData)      'show DOS where the new DTA is located
    regstr.AX = &H1A00               'specify service 1Ah in AH
    CALL Interrupt(&H21, regstr)     'DOS set DTA service
    count = 0                        'zero out the file counter
    origfilenam$ = spec$
    spec$ = spec$ + chr$(0)               'make an ASCIIZ string for DOS  
    Subdir$ = ""
    FOR k = LEN(spec$) - 1 TO 1 STEP -1
        testit$ = MID$(spec$, k, 1)
        IF testit$ = ":" OR testit$ = "\" THEN
           Subdir$ = LEFT$(spec$, k)
           EXIT FOR
        END IF
    NEXT
    regstr.DX = SADD(spec$)          'show DOS where the file spec is
    regstr.CX = 39                   'attribute for any type of file
    regstr.AX = &H4E00               'find first matching name service
    DO
       CALL Interrupt(&H21, regstr)                'see if there's a match
       IF regstr.Flags AND 1 THEN EXIT DO          'error if carry flag is set
       count = count + 1                           'show we found another one
       SurveyAvail$(count) = Subdir$ + DTAData.FileName  'copy the name to the array
       DTAData.FileName = "            "
       regstr.AX = &H4F00                       'find next matching name
    LOOP while count < 20
    FNLoadNames% = count                        'assign the function output
END DEF

     timeout = 0
     HotKey = -1
     OkaytoSayNo = -1
     Zero = 0
     locl = 0
     HotKey$ = "ON"

     demand$ = ucase$(ltrim$(command$))
     IF instr(demand$, "LOCAL") THEN
       t = instr(demand$, "LOCAL") 
       if t > 1 then
         demand$ = left$(demand$, t - 2)
       else
         demand$ = ""
       end if
       C% = 100
       locl = 1
     end if
     
     if demand$ = "" then 
       OPEN FileName$ + ".CNF" for Input as #1
          INPUT #1, PcbInfo$          '  Location of PCBOARD info file
       CLOSE 1
     else
       PcbInfo$ = demand$
     end if
     
     Gosub GetPcbData
     CALL GetSysInfo(PcbInfo$ + "PCBOARD.SYS")
     CALL GetUserInfo(PCBUserfile$, PCBoardSys.RecordNumber)
     
     GOSUB AddedCommands
     Gosub FindTimeLeft

     IF locl = 0 THEN
       If PCBoardSys.ErrorCorrect = "-1" then
          shk$ = "RTS"
       else
          Shk$ = "XON"
          xon = True
       end if
       OPENCOM "COM" + PCBoardsys.port + ":" + RTRIM$(PCBoardsys.BPSRateOpen) + ",n,8,1,RB1024,"+shk$
       ComErr = Err
       if ComErr then
          End
       end if
       c = 1
     END IF

OpeningScreen:
      if graphics then prnt cls$
      prnt ""
      prnt ""
      prnt ""
      prnt ""
      prnt ""
      prnt ""
      if Kolor then prnt cyan$
      prnt "                 Ŀ"
      prnt "                 ;"
      if Kolor then prnt magenta$ + ";"
      prnt " S   U   R   V   E   Y       D   O   O   R ;"
      if Kolor then prnt cyan$ + ";"
      prnt ""
      prnt "                 "
      prnt ""
      if Kolor then prnt magenta$ + ";"
      prnt "                   Copyright (C) 1990     by Derrick Burgess"
      if Kolor then prnt cyan$ + ";"
      lin$ = "Version " + vernum$ + "  Registered to " + BoardName$
      k = (80 - len(lin$)) \ 2
      prnt space$(k)+";"
      prnt lin$
      prnt ""
      prnt ""
      spec$ = MainSubDir$ + "*.SVY"
      count = FNLoadNames%                    'count and load the file names
      Start& = PDQTimer&
top:
      Gosub TestLines
      prnt ""
      if Kolor then prnt yellow$+";"
      prnt "           Survey Door Main Menu"
      prnt ""
      if Count > 0 then
          if Kolor then prnt cyan$+";"
          prnt "     A.;" 
          if Kolor then prnt green$+";"
          prnt "  Answer a Survey ;"
          if Kolor then prnt yellow$+";"
          prnt "(;" 
          if Kolor then prnt magenta$+";"
          prnt str$(count) + " available;" 
          if Kolor then prnt yellow$+";"
          prnt ")"
          if Kolor then prnt cyan$+";"
          prnt "     R.;" 
          if Kolor then prnt green$+";"
          prnt "  Read Survey Results"
          if kolor then prnt cyan$ + ";"
          prnt "     H.;"
          if Kolor then prnt green$+";"
          prnt "  Toggle Hotkeys (HotKeys are currently ;"
          If Kolor then Prnt red$+";"
          prnt hotkey$ + ";"
          if Kolor then prnt green$+";"
          prnt ")"
          if Kolor then prnt cyan$+";"
          prnt "     I.;" 
          if Kolor then prnt green$+";"
          prnt "  Instructions on how to use the Survey Door"
      Else
          if Kolor then prnt red$+";"
          prnt "     Sorry, No Surveys are available at this time."
      end if
      if kolor then prnt cyan$ + ";"
      prnt "     W.;"
      if Kolor then prnt green$+";"
      prnt "  Information on how to write your own survey."
      if kolor then prnt cyan$ + ";"
      prnt "     Q.;"
      if Kolor then prnt green$+";"
      prnt "  Quit - Return to System"
      prnt ""
      gosub timeline
      prnt " Survey Command? ;"
      if Kolor then prnt yellow$+";"
      Inpt Answer$, 1
      Gosub TestLines
      answer$ = ucase$(answer$)
      if Answer$ = "A" then
         if count > 0 then goto AnswerSurvey
      Elseif Answer$ = "R" then
         if count > 0 then Goto ReadSurvey
      elseif Answer$ = "H" then
         if HotKey$ = "ON" then
            HotKey = 0
            HotKey$ = "OFF"
         else
            HotKey = -1
            HotKey$ = "ON"
         end if
      elseif Answer$ = "I" then
         prnt ""
         ShowFile$ = FileName$ + ".INF"
         Goto ShowFile
      Elseif Answer$ = "W" then
         prnt ""
         showfile$ = FileName$ + ".HOW"
         Goto ShowFile   
      elseif answer$ = "Q" then
         Goto Goodbye
      End if 
      
      Goto Top
      
GoodBye:
      if kolor then prnt white$+";"
      prnt "Returning to PCBoard now..."
      Close
      CloseCom
      END
      
timeline:
      if kolor then prnt yellow$+ ";"
      prnt "(;"
      if kolor then prnt magenta$+";"
      prnt str$(minutsleft) +";"
      prnt " min. left;"
      if kolor then prnt yellow$+";"
      prnt ");"
      if kolor then prnt white$+";"
      return
      
AnswerSurvey:
      Gosub TestLines
      prnt ""
      if kolor then prnt cyan$+";"
      prnt "          These Surveys are available:  ( - Survey's you've already answered)"
      prnt ""
      Gosub ShowAvail
      if kolor then prnt cyan$+";"
      prnt "    X.;"
      if kolor then prnt green$+";"
      prnt "   Exit without Answering a Survey - Return to Main Menu"
      prnt ""
      Gosub Timeline
      prnt " Answer Which Survey? ;"
      if Kolor then prnt yellow$+";"
      Inpt Answer$, 1
      Gosub TestLines
      Answer$ = ucase$(Answer$)
      if Answer$ = "X" then
         Goto Top
      end if
      Whichone = ASC(answer$) - 64
      if Whichone > Count or whichone < 1 then goto AnswerSurvey
      Gosub IfAnswered
      If Found = 1 then
        prnt ""
        if kolor then prnt red$+";"
        prnt "Sorry "+rtrim$(PCBoardSys.FirstName)+ ", but you have already answered this survey!"
        prnt ""
        Goto Top
      end if
      Gosub OpenSurvey
      Gosub GetNextLine
      DO
        If NOT repeat then lastplc = loc(d%)
        Gosub GetNextLine
      LOOP UNTIL left$(temp$, 1) <> ">"
      DO
         if left$(temp$, 1) = "=" then
            CreateBulletinYes = 1
            Bulletin$ = ltrim$(mid$(temp$, 2))
            Gosub GetNextLine
         end if
         if left$(temp$, 3) = "DOS" then
            dos$ = ltrim$(mid$(temp$, 4))
            shellhuh  = 1
            Gosub GetNextLine
         end if
         while left$(temp$, 1) = "@"
            prnt (mid$(temp$, 2))
            Gosub GetNextLine
         wend
      loop until left$(temp$, 1) <> "@" and left$(temp$, 1) <> "=" and left$(temp$, 3) <> "DOS"
      Question = 0
      Do
        Question = Question + 1
        If Graphics then prnt Cls$
        prnt ""
        if kolor then prnt cyan$+";"
        prnt "Question: "+str$(Question)
        prnt ""
        if repeat = 0 then prevplc = lastplc
        Gosub ShowQuestion
        if OkayToSayNo then
            if kolor then prnt yellow$+";"
            prnt "    -   ;"
            if kolor then prnt magenta$+";"
            prnt "I prefer not to answer this question."
        end if
        prnt ""
        if kolor then prnt green$+";"
        prnt "         Your Response: ;"
        if Kolor then prnt yellow$+";"
        DO
          inpt answer$, 1
        Loop Until Answer$ <> chr$(13)
        Gosub TestLines
        prnt ""
        answer = asc(ucase$(answer$))-64
        repeat = 0
        if (answer > choices or answer < 1) and (answer$ <> "-" AND OkayToSayNo) then
            seek #d%, prevplc
            Question = Question - 1
            repeat = -1
            Gosub GetNextLine
        else
            if answer$ <> "-" then SurveyAnswer(Question) = Answer
        end if
      Loop Until ucase$(rtrim$(ltrim$(temp$))) = "END" or EOF(d%)
      prnt ""
      prnt "Are you satisfied with your Answers? ;"
      inpt a$, 1
      if A$ = "N" or A$ = "n" then
        if Kolor then prnt green$ + ";"
        prnt ""
        prnt "     Aborting Survey - NOT saving answers..."
        prnt "     You may fill out the survey again if you wish"
        Close d%
        close r%
        goto top
      end if
      Gosub StoreAnswers
      Gosub AddAnsweree
      Close d%
      Close r%
      prnt ""
      prnt "Thank you for answering this survey!"
      if CreateBulletinYes = 1 then
         prnt "Please Wait one moment - Updating Bulletin"
         CreateBulletin = 1
         OrigKolor = Kolor
         Kolor = -1
         for bltnum = 1 to 2
           Kolor = NOT Kolor
           bulletin% = freeFile
           if Kolor then
              Open Bulletin$+"G" for Output as bulletin%
           Else
              Open Bulletin$ for Output as bulletin%
           end if
           prnt "Created by Survey door v"+vernum$+"   By Derrick Burgess   Copyright (C) 1990"
           prnt ""
           prnt "                         Survey Results as of " + date$
           prnt ""
           prnt ""
           Gosub OpenSurvey
           DO
             lastplc = loc(d%)
             Gosub GetNextLine
             While lefT$(temp$, 1) = ">"
                lent = (80 - len(mid$(temp$, 2))) \ 2
                prnt space$(lent) + mid$(temp$, 2)
                input #d%, temp$
             wend
           LOOP UNTIL left$(temp$, 1) <> ">" and left$(temp$, 1) <> "=" and left$(temp$, 3) <> "DOS" and left$(temp$, 1) <> "@"
           prnt ""
           Question = 0
           Do
             Question = Question + 1
             prnt ""
             prnt "Question #"+str$(Question)
             prnt ""
             Gosub ShowResults
             prnt ""
           Loop Until ucase$(rtrim$(ltrim$(temp$))) = "END" or EOF(d%)
           Close d%
           Close r%
           Close Bulletin%
         NEXT
         CreateBulletin = 0
         Kolor = OrigKolor
      end if
      if ShellHuh = 1 then
         shell Dos$
      end if
      prnt ""
      Goto Top
      
StoreAnswers:
      For Looop = 1 to Question
            repeat = 0
            plac = (Looop - 1) * 50 + ((SurveyAnswer(looop) - 1) * 2) + 1
            Get #r, plac, prevanswers
            prevanswers = prevanswers + 1
            put #r, plac, prevanswers
      NEXT
      RETURN
      
GetNextLine:
   Do
      Input #d, temp$
   loop until rtrim$(temp$) <> "" or ucase$(rtrim$(ltrim$(temp$))) = "END" or EOF(d%)
return

ShowAvail:
      for k = 1 to count
         if kolor then prnt cyan$ + ";"
         prnt "  ;"
         Whichone = k
         Gosub IfAnswered 
         if Found = 1 then
            if kolor then prnt yellow$ + ";"
            prnt ";" 
         else 
            prnt " ;"
         end if
         if kolor then prnt cyan$ + ";"
         prnt " " + chr$(k + 64) + ".   ;"
         if kolor then prnt green$ + ";"
         D% = FREEFILE
         Open SurveyAvail$(k) for Input as #d%
           input #d%, temp$
           prnt mid$(temp$,2)
           input #d%, temp$
           While lefT$(temp$, 1) = ">"
             prnt "         " + mid$(temp$, 2)
             input #d%, temp$
           wend
         Close #d%
      next
return

ShowQuestion:
        if kolor then prnt white$+";"
        Do
          tmp$ = ltrim$(temp$)
          size = len(temp$) - len(tmp$)
          if size = 0 then
              prnt tmp$
              Gosub GetNextLine
          end if
        loop until size <> 0
        Choices = 0
        LastSize = Size
        prnt ""
        Do
          tmp$ = ltrim$(temp$)
          Size = len(Temp$) - len(tmp$)
          if Size = 0 or tmp$ = "" then 
            Exit Do
          elseif Size <= lastsize then
            Choices = Choices + 1
            if kolor then prnt yellow$+";"
            prnt "    " + chr$(choices + 64) + ".  ;"
            if kolor then prnt magenta$+";"
            prnt Tmp$
          else
            if kolor then prnt magenta$+";"
            prnt "        " + tmp$
          end if
          if NOT repeat then lastplc = loc(d%)
          Gosub GetNextLine
        Loop
return

ShowResults:
        if kolor then prnt cyan$+";"
        Do
          tmp$ = ltrim$(temp$)
          size = len(temp$) - len(tmp$)
          if size = 0 then
              prnt tmp$
              Gosub GetNextLine
          end if
        loop until size <> 0
        Choices = 0
        LastSize = Size
        prnt ""
        total = 0
        for looop = 1 to 24
             Atplc = (Question - 1) * 50 + ((looop - 1) * 2) + 1
             Get #r, atplc, temp
             repAnswers(looop) = temp
             total = total + temp
        next
        if total = 0 then total = 1
        Do
          tmp$ = ltrim$(temp$)
          Size = len(Temp$) - len(tmp$)
          if Size = 0 or tmp$ = "" then 
            Exit Do
          elseif Size <= lastsize then
            Choices = Choices + 1
            numAnswer$ = left$(rtrim$(str$(repAnswers(choices))) + "    ", 3)
            number = (repAnswers(choices) * 100) \ total
            numtotal$ = str$(number)
            percent$ = rtrim$(numtotal$)
            percent$ = space$(3 - Len(percent$)) + percent$
            if kolor then prnt magenta$+";"
            prnt "   " + NumAnswer$ + ";"
            if kolor then prnt green$+";"
            prnt " ("+ percent$ + "%) ;"
            if kolor then prnt yellow$+";"
            prnt Tmp$            
          else
            if kolor then prnt magenta$+";"
            prnt "                 " + tmp$
          end if
          Gosub GetNextLine
        Loop
        if kolor then prnt white$+";"
return

OpenSurvey:
      d% = FreeFile
      Open SurveyAvail$(WhichOne) for Input as #d%
        ResponseFile$ = left$(SurveyAvail$(Whichone), len(rtrim$(SurveyAvail$(Whichone))) - 3) + "RSP"
        R% = FreeFile
        Open ResponseFile$ for Binary as #r%
        if lof(r%) = 0 then
           Close #r
           Open ResponseFile$ for OutPut as #r%
           Seek #r, 1
           for looop = 1 to 500
             put #r, , Zero
           NEXt
           Close #r%
           Open ResponseFile$ for Binary as #r%
        end if
return
      
ReadSurvey:         
      Gosub TestLines
      if Kolor then prnt Yellow$ + ";"
      prnt ""
      prnt "  The surveys marked  are available to read since you've answered them first:"
      prnt ""
      Gosub ShowAvail
      if kolor then prnt cyan$+";"
      prnt "    X.;"
      if kolor then prnt green$+";"
      prnt "   Exit without Reading a Survey - Return to Main Menu"
      prnt ""
      Gosub timeline
      prnt " Read Results From Which Survey? ;"
      if Kolor then prnt yellow$+";"
      Inpt Answer$, 1
      Gosub TestLines
      Answer$ = ucase$(Answer$)
      if Answer$ = "X" then
         Goto Top
      end if
      Whichone = ASC(answer$) - 64
      if Whichone > Count or whichone < 1 then goto ReadSurvey
      Gosub IfAnswered
      if Found = 0 then
         prnt ""
         If Kolor then prnt Red$+";"
         prnt "You have not yet answered this survey. You must answer the survey
         prnt "before you can read the results.  Please answer the survey first - Thank you."
         prnt ""
         goto ReadSurvey
      end if
      Gosub OpenSurvey
      Gosub GetNextLine
      DO
        Gosub GetNextLine
      LOOP UNTIL left$(temp$, 1) <> ">" and left$(temp$, 1) <> "=" and left$(temp$, 3) <> "DOS" and left$(temp$, 1) <> "@"
      Question = 0
      Do
        Question = Question + 1
        if Graphics then prnt Cls$
        prnt ""
        prnt ""
        if kolor then prnt yellow$+";"
        prnt "Question #"+str$(Question)
        prnt ""
        Gosub ShowResults
        prnt ""
        prnt ""
        waitn
      Loop Until ucase$(rtrim$(ltrim$(temp$))) = "END" or EOF(d%)
      Close d%
      Close r%
      prnt ""
      if Kolor then prnt green$+";"
      prnt "Thank you for reading the results to this survey!"
      prnt ""
      Goto Top
      
'------------------------------------------------------------
TestLines:
    now& = PDQTimer&
    used& = Now& - Start&
    if used& < 0 then Start& = 0
    minutesused& = used& \ 1092
    minutsleft = PCBoardSys.Minutesleft - minutesused&
     
    if c < 100 then
        If NOT Carrier% then Goto NoCarrier
    end if
     
    If TimeOut = 1 then goto TimeOut
     
    if minutsleft = 0 then goto NoTimeLeft
    Return
'------------------------------------------------------------
NoTimeLeft:
    prnt ""
    if kolor then prnt blue$+";"
    prnt "  Sorry, you have ran out of Time - Please Call again tommorow"
    prnt ""
    Goto Goodbye
  
TimeOut:
    prnt ""
    if kolor then prnt red$+";"
    prnt "Keyboard Timeout - Returning to Board"
    prnt ""
    goto Goodbye
   
NoCarrier:            'Expand?
    Close
    CloseCom
    End
   
FindTimeLeft:
    if C < 100 then
       minutsleft = PCBoardSys.MinutesLeft
    else
       minutsleft = 100
    end if
    Return
    
ShowFile:
    ins% = freefile
    shol= 0
    if NOT pdqexist(showfile$) then
      if Kolor then prnt red$ + ";"
      prnt ""
      prnt "Error - " +showfile$+" File Missing, Please notify Sysop"
      prnt ""
      waitn
      Goto Top
    end if
    Open showfile$ for Input as #ins%
    showmax = asc(user.PageLength) - 1
    if showmax = 0 or showmax = - 1 then showmax = 22
    If Kolor then prnt yellow$ + ";"
    While Not Eof(ins%)
      input #ins%, inst$
      prnt inst$
      shol = shol + 1
      if shol mod showmax = 0 then
         Waitn
         prnt ""
         if Kolor then prnt Yellow$ + ";"
      end if
    wend
    close ins%
    prnt ""
    if shol mod showmax > 10 then waitn
    goto Top
   
'------------------------------------------------------------
AddAnsweree:      
      p% = FreeFile
      Open AnswerFile$ for Binary as #p%
        if lof(p%) = 0 then
           Close #p%
           Open AnswerFile$ for OUTPUT as #p%
           Print #p%, rtrim$(PCBoardSys.UserName) + " | " + Date$
        else
           Seek #p%, lof(p%) + 1
           Print #p%, Rtrim$(PCBoardSys.UserName) + " | " + Date$
        end if
      Close #p%
return
'------------------------------------------------------------
IfAnswered:
      AnswerFile$ = left$(SurveyAvail$(Whichone), len(rtrim$(SurveyAvail$(Whichone))) - 3) + "REP"
      p% = FreeFile
      Found = 0
      Open AnswerFile$ for Binary as #p%
      if lof(p%) <> 0 then
         While Not EOF(p%) and found = 0
           input #p%, temp$
           if rtrim$(PCBoardSys.UserName) = left$(temp$, instr(temp$, " | ")-1) then
              Found = 1
           end if
         wend
      end if
      Close #p%
return

'------------------------------------------------------------
AddedCommands:
   Return$ = CHR$(13)
   LineFeed$ = CHR$(10)
   end$ = Return$ + LineFeed$
   Esc$ = CHR$(27)
   cls$ = Esc$ + "[2j"
   Red$ = Esc$ + "[1;31m"
   Green$ = Esc$ + "[1;32m"
   Yellow$ = Esc$ + "[1;33m"
   Blue$ = Esc$ + "[1;34m"
   Magenta$ = Esc$ + "[1;35m"
   Cyan$ = Esc$ + "[1;36m"
   White$ = Esc$ + "[1;37m"
   Grey$ = Esc$ + "[0m"
RETURN

'------------------------------------------------------------
GetPcbData:
    k% = Freefile
    Open PCBinfo$ + "PCBOARD.DAT" for Input as #k%
    Input #k, temp$
    input #k, Sysop$
    for g = 1 to 26  
        input #k, temp$
    next
    input #k, PcbUserFile$
    input #k, PCBcallerfile$
    for g = 1 to 58
        input #k, temp$
    next
    Input #k, KBtimeOut$
    for g = 1 to 4
        Input #k, Temp$
    next
    input #k, BoardName$
    Close k%
return

'-----------------------------------------------------------
SUB GetUserInfo(PcbFile$, UserNum)
    k% = FREEFILE
    OPEN PcbFile$ for Binary as #k%
    Plac& = (UserNum - 1) * LEN(USER) + 1
    Get k%, plac&, User
    CLOSE k%
END SUB

SUB GetSysInfo(PcbFile$)
   if c < 100 then
    k% = FREEFILE
    OPEN PcbFile$ for Binary as #k%
    Get k%, 1, PCBoardSys
    CLOSE k%
   Else
    PCBoardSys.UserName = "SYSOP                  "
    PCBoardSys.Graphics = "Y"
    PCBoardSys.FirstName = "SYSOP         "
    PCBoardSys.RecordNumber = 1
    PCBoardSys.MinutesLeft = 100
   end if
   If PCBoardsys.Graphics = "Y" then
       kolor = -1
       Graphics = -1
   END IF
END SUB

SUB prnt (line$)
       if Right$(Line$, 1) = ";" then
         Dline$ = left$(line$, len(line$) - 1)
         Noret = 1
       else
         origline$ = line$
         Dline$ = line$ + End$
         noret = 0
       end if
       if CreateBulletin = 0 then
          If NoRet = 0 then
             print origline$
          else
             print Dline$;
          end if
          IF C < 100 THEN
             If Xoff Then
                temp = 0
                Do
                 if NOT (Xoff) then Exit Do
                 temp = temp + 1
                 if temp > 20000 then
                   ClearXoff
                   Exit Do
                 end if
               loop
             End if
             Comprint DLine$
          End If
       Else
          print #bulletin ,dline$;
       end if
END SUB

Sub Inpt (Line$, lnt)
    actlnt = 0
    if HotKey = 0 then actlnt = actlnt - 2
    Line$ = ""
    If C < 100 then
       looop& = 0
       Do
         Looop& = Looop& + 1
         k$ = inkey$
         if k$ <> "" then
            Temp$ = k$
         else
            Temp$ = Cominput$(1)
         end if
         if (Temp$ = chr$(13) and len(line$)) or (lnt = NoEcho and temp$ <> "") then Exit Do
         if NOT Carrier% then
            NoCarrier = 1
            Exit Do
         end if
         if len(Temp$) then
            if Temp$ = chr$(8) then
               if len(line$) then
                  actlnt = actlnt - 1
                  line$ = left$(line$, len(line$) - 1)
                  locate csrlin, pos(0) - 1
                  print " ";
                  locate csrlin, pos(0) - 1
               else
                  temp$ = ""
               end if
            Else
               line$ = line$ + temp$
               actlnt = actlnt + 1
            end if
            if lnt <> NoEcho then
               Comprint Temp$
               print temp$;
            end if
            if lnt = aclnt then exit do
            if len(line$) > 0 and Hotkey then exit do
            Looop& = 0
         else
            If Looop& = 100000 then
               TimeOut = 1
               Exit DO
            end if
         end if
       Loop
       if lnt <> NoEcho then
          Comprint End$
          print
       end if
    Else
       Do
         j$ = ""
         While j$ = ""
           j$ = inkey$
         Wend
         if j$ = chr$(13) or lnt = NoEcho then
             exit DO
         end if
         if j$ = chr$(8) then
             if len(line$) then
                line$ = left$(line$, len(line$) - 1)
                actlnt = actlnt - 1
                locate csrlin, pos(0) - 1
                print " ";
                locate csrlin, pos(0) - 1
             end if
         else
             print j$;    
             actlnt = actlnt + 1
             line$ = line$ + j$
             if lnt = actlnt then exit do
             if Hotkey then exit do
         end if
       Loop
       print
    end if
    lnt = len(line$)
end sub

Sub Waitn
      if pos(0) > 1 then prnt ""
      Displines = 0
      if kolor then prnt cyan$+";"
      prnt "Press Any Key to Continue ;"
      noeco = NoEcho
      inpt answer$, NoEco
      if User.PositiveDelete = "Y" then
        prnt string$(25,8) + ";"
      end if
      Displines = 0
end sub
